From ebb53fdd593605b2c49f840eb543937d83056773 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Fri, 9 Jul 2021 23:47:40 +0000
Subject: [PATCH] [arm64] improve luma_hps

before the patch:
luma_hps[  4x4]		7.26x 	 155.66   	 1130.24
luma_hps[  8x8]		13.19x 	 229.34   	 3025.77
luma_hps[  8x4]		12.82x 	 170.88   	 2190.91
luma_hps[  4x8]		7.39x 	 209.01   	 1544.11
luma_hps[ 8x16]		13.33x 	 346.17   	 4614.47
luma_hps[12x16]		10.92x 	 628.93   	 6869.03
luma_hps[ 4x16]		7.42x 	 316.50   	 2348.13
luma_hps[24x32]		14.09x 	 1627.97  	 22935.64
luma_hps[ 8x32]		13.48x 	 579.82   	 7815.91

with the patch:
luma_hps[  4x4]		7.25x 	 154.91   	 1123.54
luma_hps[  8x8]		13.25x 	 229.03   	 3033.61
luma_hps[16x16]		13.90x 	 655.11   	 9105.27
luma_hps[32x32]		14.20x 	 2154.92  	 30597.96
luma_hps[64x64]		14.57x 	 7626.98  	 111121.77
luma_hps[  8x4]		12.98x 	 170.83   	 2218.02
luma_hps[  4x8]		7.38x 	 209.01   	 1543.31
luma_hps[ 16x8]		13.91x 	 427.22   	 5942.64
luma_hps[ 8x16]		13.31x 	 346.14   	 4607.25
luma_hps[32x16]		14.29x 	 1263.49  	 18052.49
luma_hps[16x32]		14.08x 	 1097.46  	 15447.23
luma_hps[64x32]		14.33x 	 4257.39  	 60995.71
luma_hps[32x64]		14.38x 	 3860.87  	 55516.82
luma_hps[16x12]		14.15x 	 533.02   	 7541.39
luma_hps[12x16]		10.92x 	 628.27   	 6861.97
luma_hps[ 16x4]		13.94x 	 312.73   	 4360.99
luma_hps[ 4x16]		7.44x 	 316.14   	 2352.54
luma_hps[32x24]		14.37x 	 1695.62  	 24370.08
luma_hps[24x32]		14.08x 	 1628.42  	 22924.21
luma_hps[ 32x8]		14.27x 	 821.42   	 11721.52
luma_hps[ 8x32]		13.49x 	 579.23   	 7815.46
luma_hps[64x48]		14.60x 	 5892.16  	 86022.95
luma_hps[48x64]		14.59x 	 5724.71  	 83546.84
luma_hps[64x16]		14.50x 	 2484.56  	 36024.81
luma_hps[16x64]		14.15x 	 1979.60  	 28009.11
---
 source/common/aarch64/asm-primitives.cpp |  55 ++++----
 source/common/aarch64/ipfilter8.S        | 169 +++++++++++------------
 source/common/aarch64/ipfilter8.h        |  51 ++++---
 source/common/arm/ipfilter8.S            |   2 -
 4 files changed, 129 insertions(+), 148 deletions(-)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index f20f940..a5fb26e 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -110,34 +110,6 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
 
         // quant
         p.quant = PFX(quant_neon);
-        // luma_hps
-        p.pu[LUMA_4x4].luma_hps   = PFX(interp_8tap_horiz_ps_4x4_neon);
-        p.pu[LUMA_4x8].luma_hps   = PFX(interp_8tap_horiz_ps_4x8_neon);
-        p.pu[LUMA_4x16].luma_hps  = PFX(interp_8tap_horiz_ps_4x16_neon);
-        p.pu[LUMA_8x4].luma_hps   = PFX(interp_8tap_horiz_ps_8x4_neon);
-        p.pu[LUMA_8x8].luma_hps   = PFX(interp_8tap_horiz_ps_8x8_neon);
-        p.pu[LUMA_8x16].luma_hps  = PFX(interp_8tap_horiz_ps_8x16_neon);
-        p.pu[LUMA_8x32].luma_hps  = PFX(interp_8tap_horiz_ps_8x32_neon);
-        p.pu[LUMA_12x16].luma_hps = PFX(interp_8tap_horiz_ps_12x16_neon);
-        p.pu[LUMA_24x32].luma_hps = PFX(interp_8tap_horiz_ps_24x32_neon);
-#if !AUTO_VECTORIZE || GCC_VERSION < GCC_5_1_0 /* gcc_version < gcc-5.1.0 */
-        p.pu[LUMA_16x4].luma_hps  = PFX(interp_8tap_horiz_ps_16x4_neon);
-        p.pu[LUMA_16x8].luma_hps  = PFX(interp_8tap_horiz_ps_16x8_neon);
-        p.pu[LUMA_16x12].luma_hps = PFX(interp_8tap_horiz_ps_16x12_neon);
-        p.pu[LUMA_16x16].luma_hps = PFX(interp_8tap_horiz_ps_16x16_neon);
-        p.pu[LUMA_16x32].luma_hps = PFX(interp_8tap_horiz_ps_16x32_neon);
-        p.pu[LUMA_16x64].luma_hps = PFX(interp_8tap_horiz_ps_16x64_neon);
-        p.pu[LUMA_32x8].luma_hps  = PFX(interp_8tap_horiz_ps_32x8_neon);
-        p.pu[LUMA_32x16].luma_hps = PFX(interp_8tap_horiz_ps_32x16_neon);
-        p.pu[LUMA_32x24].luma_hps = PFX(interp_8tap_horiz_ps_32x24_neon);
-        p.pu[LUMA_32x32].luma_hps = PFX(interp_8tap_horiz_ps_32x32_neon);
-        p.pu[LUMA_32x64].luma_hps = PFX(interp_8tap_horiz_ps_32x64_neon);
-        p.pu[LUMA_48x64].luma_hps = PFX(interp_8tap_horiz_ps_48x64_neon);
-        p.pu[LUMA_64x16].luma_hps = PFX(interp_8tap_horiz_ps_64x16_neon);
-        p.pu[LUMA_64x32].luma_hps = PFX(interp_8tap_horiz_ps_64x32_neon);
-        p.pu[LUMA_64x48].luma_hps = PFX(interp_8tap_horiz_ps_64x48_neon);
-        p.pu[LUMA_64x64].luma_hps = PFX(interp_8tap_horiz_ps_64x64_neon);
-#endif
 
         p.pu[LUMA_8x4].luma_hvpp   =  interp_8tap_hv_pp_cpu<LUMA_8x4>;
         p.pu[LUMA_8x8].luma_hvpp   =  interp_8tap_hv_pp_cpu<LUMA_8x8>;
@@ -471,6 +443,33 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_64x32].luma_hpp = PFX(interp_horiz_pp_64x32_neon);
         p.pu[LUMA_64x48].luma_hpp = PFX(interp_horiz_pp_64x48_neon);
         p.pu[LUMA_64x64].luma_hpp = PFX(interp_horiz_pp_64x64_neon);
+
+        // luma_hps
+        p.pu[LUMA_4x4].luma_hps   = PFX(interp_horiz_ps_4x4_neon);
+        p.pu[LUMA_4x8].luma_hps   = PFX(interp_horiz_ps_4x8_neon);
+        p.pu[LUMA_4x16].luma_hps  = PFX(interp_horiz_ps_4x16_neon);
+        p.pu[LUMA_8x4].luma_hps   = PFX(interp_horiz_ps_8x4_neon);
+        p.pu[LUMA_8x8].luma_hps   = PFX(interp_horiz_ps_8x8_neon);
+        p.pu[LUMA_8x16].luma_hps  = PFX(interp_horiz_ps_8x16_neon);
+        p.pu[LUMA_8x32].luma_hps  = PFX(interp_horiz_ps_8x32_neon);
+        p.pu[LUMA_12x16].luma_hps = PFX(interp_horiz_ps_12x16_neon);
+        p.pu[LUMA_16x4].luma_hps  = PFX(interp_horiz_ps_16x4_neon);
+        p.pu[LUMA_16x8].luma_hps  = PFX(interp_horiz_ps_16x8_neon);
+        p.pu[LUMA_16x12].luma_hps = PFX(interp_horiz_ps_16x12_neon);
+        p.pu[LUMA_16x16].luma_hps = PFX(interp_horiz_ps_16x16_neon);
+        p.pu[LUMA_16x32].luma_hps = PFX(interp_horiz_ps_16x32_neon);
+        p.pu[LUMA_16x64].luma_hps = PFX(interp_horiz_ps_16x64_neon);
+        p.pu[LUMA_24x32].luma_hps = PFX(interp_horiz_ps_24x32_neon);
+        p.pu[LUMA_32x8].luma_hps  = PFX(interp_horiz_ps_32x8_neon);
+        p.pu[LUMA_32x16].luma_hps = PFX(interp_horiz_ps_32x16_neon);
+        p.pu[LUMA_32x24].luma_hps = PFX(interp_horiz_ps_32x24_neon);
+        p.pu[LUMA_32x32].luma_hps = PFX(interp_horiz_ps_32x32_neon);
+        p.pu[LUMA_32x64].luma_hps = PFX(interp_horiz_ps_32x64_neon);
+        p.pu[LUMA_48x64].luma_hps = PFX(interp_horiz_ps_48x64_neon);
+        p.pu[LUMA_64x16].luma_hps = PFX(interp_horiz_ps_64x16_neon);
+        p.pu[LUMA_64x32].luma_hps = PFX(interp_horiz_ps_64x32_neon);
+        p.pu[LUMA_64x48].luma_hps = PFX(interp_horiz_ps_64x48_neon);
+        p.pu[LUMA_64x64].luma_hps = PFX(interp_horiz_ps_64x64_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index a2f72de..30aae93 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -1987,129 +1987,65 @@ LUMA_HPP    64 48
 LUMA_HPP    64 64
 
 // void interp_horiz_ps_c(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt)
-.macro HPS_FILTER a b filterhps
+.macro HPS_FILTER w h filterhps
     mov             w12, #8192
+    dup             v30.4s, w12
     mov             w6, w10
-    sub             x3, x3, #\a
+    sub             x3, x3, #\w
     lsl             x3, x3, #1
-    mov             w9, #\a
+    mov             w9, #\w
     cmp             w9, #4
     b.eq            14f
     cmp             w9, #12
     b.eq            15f
     b               7f
 14:
-    HPS_FILTER_4 \a \b \filterhps
-    b               10f
-15:
-    HPS_FILTER_12 \a \b \filterhps
-    b               10f
-7:
-    cmp             w5, #0
-    b.eq            8f
-    cmp             w5, #1
-    b.eq            9f
-8:
-loop1_hps_\filterhps\()_\a\()x\b\()_rowext0:
-    mov             w7, #\a
-    lsr             w7, w7, #3
-    mov             x11, x0
-    sub             x11, x11, #4
-loop2_hps_\filterhps\()_\a\()x\b\()_rowext0:
-    vextin8
-    \filterhps
-    dup             v16.4s, w12
-    sub             v17.4s, v17.4s, v16.4s
-    sub             v18.4s, v18.4s, v16.4s
-    xtn             v0.4h, v17.4s
-    xtn2            v0.8h, v18.4s
-    st1             {v0.8h}, [x2], #16
-    subs            w7, w7, #1
-    sub             x11, x11, #8
-    b.ne            loop2_hps_\filterhps\()_\a\()x\b\()_rowext0
-    subs            w6, w6, #1
-    add             x0, x0, x1
-    add             x2, x2, x3
-    b.ne            loop1_hps_\filterhps\()_\a\()x\b\()_rowext0
-    b               10f
-9:
-loop3_hps_\filterhps\()_\a\()x\b\()_rowext1:
-    mov             w7, #\a
-    lsr             w7, w7, #3
-    mov             x11, x0
-    sub             x11, x11, #4
-loop4_hps_\filterhps\()_\a\()x\b\()_rowext1:
-    vextin8
-    \filterhps
-    dup             v16.4s, w12
-    sub             v17.4s, v17.4s, v16.4s
-    sub             v18.4s, v18.4s, v16.4s
-    xtn             v0.4h, v17.4s
-    xtn2            v0.8h, v18.4s
-    st1             {v0.8h}, [x2], #16
-    subs            w7, w7, #1
-    sub             x11, x11, #8
-    b.ne            loop4_hps_\filterhps\()_\a\()x\b\()_rowext1
-    subs            w6, w6, #1
-    add             x0, x0, x1
-    add             x2, x2, x3
-    b.ne            loop3_hps_\filterhps\()_\a\()x\b\()_rowext1
-10:
-.endm
-
-.macro HPS_FILTER_4 w h filterhps
     cmp             w5, #0
     b.eq            11f
     cmp             w5, #1
     b.eq            12f
 11:
-loop4_hps_\filterhps\()_\w\()x\h\()_rowext0:
+.loop4_hps_\filterhps\()_\w\()x\h\()_rowext0:
     mov             x11, x0
     sub             x11, x11, #4
     vextin8
     \filterhps
-    dup             v16.4s, w12
-    sub             v17.4s, v17.4s, v16.4s
+    sub             v17.4s, v17.4s, v30.4s
     xtn             v0.4h, v17.4s
     st1             {v0.4h}, [x2], #8
-    sub             x11, x11, #8
-    subs            w6, w6, #1
+    sub             w6, w6, #1
     add             x0, x0, x1
     add             x2, x2, x3
-    b.ne            loop4_hps_\filterhps\()_\w\()x\h\()_rowext0
+    cbnz            w6, .loop4_hps_\filterhps\()_\w\()x\h\()_rowext0
     b               13f
 12:
-loop5_hps_\filterhps\()_\w\()x\h\()_rowext1:
+.loop5_hps_\filterhps\()_\w\()x\h\()_rowext1:
     mov             x11, x0
     sub             x11, x11, #4
     vextin8
     \filterhps
-    dup             v16.4s, w12
-    sub             v17.4s, v17.4s, v16.4s
+    sub             v17.4s, v17.4s, v30.4s
     xtn             v0.4h, v17.4s
     st1             {v0.4h}, [x2], #8
-    sub             x11, x11, #8
-    subs            w6, w6, #1
+    sub             w6, w6, #1
     add             x0, x0, x1
     add             x2, x2, x3
-    b.ne            loop5_hps_\filterhps\()_\w\()x\h\()_rowext1
+    cbnz            w6, .loop5_hps_\filterhps\()_\w\()x\h\()_rowext1
 13:
-.endm
-
-.macro HPS_FILTER_12 w h filterhps
+    b               10f
+15:
     cmp             w5, #0
     b.eq            14f
     cmp             w5, #1
     b.eq            15f
 14:
-loop12_hps_\filterhps\()_\w\()x\h\()_rowext0:
+.loop12_hps_\filterhps\()_\w\()x\h\()_rowext0:
     mov             x11, x0
     sub             x11, x11, #4
     vextin8
     \filterhps
-    dup             v16.4s, w12
-    sub             v17.4s, v17.4s, v16.4s
-    sub             v18.4s, v18.4s, v16.4s
+    sub             v17.4s, v17.4s, v30.4s
+    sub             v18.4s, v18.4s, v30.4s
     xtn             v0.4h, v17.4s
     xtn2            v0.8h, v18.4s
     st1             {v0.8h}, [x2], #16
@@ -2117,24 +2053,22 @@ loop12_hps_\filterhps\()_\w\()x\h\()_rowext0:
 
     vextin8
     \filterhps
-    dup             v16.4s, w12
-    sub             v17.4s, v17.4s, v16.4s
+    sub             v17.4s, v17.4s, v30.4s
     xtn             v0.4h, v17.4s
     st1             {v0.4h}, [x2], #8
     add             x2, x2, x3
-    subs            w6, w6, #1
+    sub             w6, w6, #1
     add             x0, x0, x1
-    b.ne            loop12_hps_\filterhps\()_\w\()x\h\()_rowext0
+    cbnz            w6, .loop12_hps_\filterhps\()_\w\()x\h\()_rowext0
     b               16f
 15:
-loop12_hps_\filterhps\()_\w\()x\h\()_rowext1:
+.loop12_hps_\filterhps\()_\w\()x\h\()_rowext1:
     mov             x11, x0
     sub             x11, x11, #4
     vextin8
     \filterhps
-    dup             v16.4s, w12
-    sub             v17.4s, v17.4s, v16.4s
-    sub             v18.4s, v18.4s, v16.4s
+    sub             v17.4s, v17.4s, v30.4s
+    sub             v18.4s, v18.4s, v30.4s
     xtn             v0.4h, v17.4s
     xtn2            v0.8h, v18.4s
     st1             {v0.8h}, [x2], #16
@@ -2147,15 +2081,66 @@ loop12_hps_\filterhps\()_\w\()x\h\()_rowext1:
     xtn             v0.4h, v17.4s
     st1             {v0.4h}, [x2], #8
     add             x2, x2, x3
-    subs            w6, w6, #1
+    sub             w6, w6, #1
     add             x0, x0, x1
-    b.ne            loop12_hps_\filterhps\()_\w\()x\h\()_rowext1
+    cbnz            w6, .loop12_hps_\filterhps\()_\w\()x\h\()_rowext1
 16:
+    b               10f
+7:
+    cmp             w5, #0
+    b.eq            8f
+    cmp             w5, #1
+    b.eq            9f
+8:
+.loop1_hps_\filterhps\()_\w\()x\h\()_rowext0:
+    mov             w7, #\w
+    lsr             w7, w7, #3
+    mov             x11, x0
+    sub             x11, x11, #4
+.loop2_hps_\filterhps\()_\w\()x\h\()_rowext0:
+    vextin8
+    \filterhps
+    sub             v17.4s, v17.4s, v30.4s
+    sub             v18.4s, v18.4s, v30.4s
+    xtn             v0.4h, v17.4s
+    xtn2            v0.8h, v18.4s
+    st1             {v0.8h}, [x2], #16
+    sub             w7, w7, #1
+    sub             x11, x11, #8
+    cbnz            w7, .loop2_hps_\filterhps\()_\w\()x\h\()_rowext0
+    sub             w6, w6, #1
+    add             x0, x0, x1
+    add             x2, x2, x3
+    cbnz            w6, .loop1_hps_\filterhps\()_\w\()x\h\()_rowext0
+    b               10f
+9:
+.loop3_hps_\filterhps\()_\w\()x\h\()_rowext1:
+    mov             w7, #\w
+    lsr             w7, w7, #3
+    mov             x11, x0
+    sub             x11, x11, #4
+.loop4_hps_\filterhps\()_\w\()x\h\()_rowext1:
+    vextin8
+    \filterhps
+    dup             v16.4s, w12
+    sub             v17.4s, v17.4s, v16.4s
+    sub             v18.4s, v18.4s, v16.4s
+    xtn             v0.4h, v17.4s
+    xtn2            v0.8h, v18.4s
+    st1             {v0.8h}, [x2], #16
+    sub             w7, w7, #1
+    sub             x11, x11, #8
+    cbnz            w7, .loop4_hps_\filterhps\()_\w\()x\h\()_rowext1
+    sub             w6, w6, #1
+    add             x0, x0, x1
+    add             x2, x2, x3
+    cbnz            w6, .loop3_hps_\filterhps\()_\w\()x\h\()_rowext1
+10:
 .endm
 
 // void interp_horiz_ps_c(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt)
 .macro LUMA_HPS w h
-function x265_interp_8tap_horiz_ps_\w\()x\h\()_neon
+function x265_interp_horiz_ps_\w\()x\h\()_neon
     mov             w10, #\h
     cmp             w5, #0
     b.eq            6f
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index 072ad0a..3e170b4 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -241,31 +241,30 @@ void x265_interp_horiz_pp_64x32_neon(const pixel* src, intptr_t srcStride, pixel
 void x265_interp_horiz_pp_64x48_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 void x265_interp_horiz_pp_64x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 
-void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_8x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_8x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_8x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_8x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_12x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_16x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_16x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_16x12_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_16x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_16x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_16x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_24x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_32x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_32x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_32x24_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_32x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_32x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_48x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_64x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_64x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_64x48_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-void x265_interp_8tap_horiz_ps_64x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-
+void x265_interp_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_8x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_8x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_8x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_8x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_12x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_16x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_16x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_16x12_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_16x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_16x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_16x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_24x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_32x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_32x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_32x24_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_32x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_32x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_48x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_64x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_64x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_64x48_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
+void x265_interp_horiz_ps_64x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 
 #endif // ifndef X265_IPFILTER8_AARCH64_H
diff --git a/source/common/arm/ipfilter8.S b/source/common/arm/ipfilter8.S
index b7c8578..eafb40f 100644
--- a/source/common/arm/ipfilter8.S
+++ b/source/common/arm/ipfilter8.S
@@ -2727,7 +2727,6 @@ loop4_hps_\filterhps\()_\w\()x\h\()_rowext0:
     vsub.s32        q9, q8
     vmovn.u32       d0, q9
     vst1.s16        {d0}, [r2]!
-    sub             r5, #8
     subs            r6, #1
     add             r0, r1
     add             r2, r3
@@ -2743,7 +2742,6 @@ loop5_hps_\filterhps\()_\w\()x\h\()_rowext1:
     vsub.s32        q9, q8
     vmovn.u32       d0, q9
     vst1.s16        {d0}, [r2]!
-    sub             r5, #8
     subs            r6, #1
     add             r0, r1
     add             r2, r3
-- 
2.25.1

